(require 'cl)
(require 'flange-util)
(require 'flange-timers)
(require 'flange-state)


(defun phalange-dispatch-timeouts ()
  (let ((pending (phalange-timer-pending))
	(current-time-function (symbol-function 'current-time)))
    (while pending
      (let ((when (phalange-timeout-time pending))
	    (what (phalange-timeout-name pending))) 
	(stop-timeout what)
	(lexical-let ((dispatch-at-time (lambda () when)))
	  (unwind-protect
	      (progn
		(fset 'current-time dispatch-at-time)
		(phalange-signal-event what))
	    (fset 'current-time current-time-function)))
	(setq pending (phalange-timer-pending)))
      )))


(defun phalange-dispatch-command (cmd)
  (let ((this-command cmd))
    (phalange-signal-event 'emacs-command)))


(provide 'flange-dispatch)